//camera
ifndef camera_wdl;
define camera_wdl;

entity* plate_ent;


//bounding box for camera
//these are your max, left, right & top, bottom distances inside you hollow box in wed
define left_border, -16640;
define right_border, 16640;
define top_border, 16640;
define bottom_border, -16640;
//zoom distances
define zoom_distance1, 150;
define zoom_distance2, 1280;
define zoom_distance3, 2560;
define zoom_distance4, 7680;

define zoom_tilt1, 25;
define zoom_tilt2, 60;
define zoom_tilt3, 85;

//flag for key z 
var z_pressed;
//focus point for camera
var cam_focus[3];
//angle to rotate the camera to
var cam_ang[3];
//zoom distances
var cam_dist;
//sets camera position
var cam_temp_dist;

var cam_temp_tilt;

entity* moon_ent;
entity* asteroid_ent;
entity* camera_ent;
entity* player_colors_ent;

bmap arrow = <arrowbk.pcx>;


string dummy02_mdl = <planet_sm.mdl>;

var screen_size_xpan;
var screen_size_ypan;
var pan_x4;
var pan_x2;
var pan_y4;
var pan_y2;
var pan_x0;
var pan_y0;
var pan_offsetx;
var pan_offsety;
var panel_width;
var panel_height;


view planet_cam
{
	layer = 20;
	pos_x = 1;
	pos_y = 481;
	size_x = 320;
	size_y = 240;
	flags = visible;
}

view map_cam
{
	layer 20;
	pos_x = 1;
	pos_y = 1;
	size_x = 620;
	size_y = 480;
	//flags = visible;
	
}

//
function camera_ent_func() 
{
	while(player == null){camera.visible = off;
	wait(1);
	}
	my.invisible = on;
	camera_ent = me;
	camera.visible = on;
	camera.ambient = 50;
	//camera.genius = me;
	cam_focus.x = 0;
	cam_focus.y = 0;
	//cam_focus.z = -1000;
	cam_focus.z = 50;
	cam_ang.pan = -90;
	cam_ang.tilt = 60;
	cam_ang.roll = 0;
	cam_dist = 150;
	cam_temp_dist = 150;
	
	//my.enable_scan = on;
	
	var scan_range;
	var scan_temp[3];
	var detect_temp;
	
	while (1) 
	{
	
		// Move the camera using the arrow keys (key_force). 
		// We multiply by 'Time' to keep it running the same speed at all frame rates
		// mouse at side of screen?
		if (mouse_pos.x > screen_size.x - 40 && camera.x < right_border )
		{
			temp.x = 50 * time;
		}
		
		else
		{ 
			if (mouse_pos.x < 20 && camera.x > left_border)
			{
				temp.x = -50 * time;
			}//left screen
			
			else
			{
				temp.x = 0;
			}//no speed
		}
		if (mouse_pos.y > screen_size.y - 40 && camera.y > bottom_border)
		{
			temp.y = -50 * time; 
		}//back
		
		else
		{
			if (mouse_pos.y < 20 && camera.y < top_border)
			{
				temp.y =	50 * time;
			}
			
			else
			{
				temp.y = 0;
			}
		}
		
		temp.x += (key_force.x * 30) * time;	
		if (temp.x > 30 * time) {temp.x = 30 * time;} // limit max speed
		if (temp.x < -30 * time) {temp.x = -30 * time;}
		temp.y += (key_force.y * 30) * time;
		if (temp.y > 30 * time) {temp.y = 30 * time;}
		if (temp.y < -30 * time) {temp.y = -30 * time;}
		
		
		if(mouse_pos.x > screen_size.x-bmap_width(arrow)) {
			mouse_pos.x = screen_size.x-bmap_width(arrow); 
		}
    	if(mouse_pos.y > screen_size.y-bmap_height(arrow)) {
      mouse_pos.y = screen_size.y-bmap_height(arrow); 
    	}

		cam_focus.x += temp.x; //update the vectors when mouse moves
		cam_focus.y += temp.y;
		vec_set(camera.x,cam_temp_dist);//set the camera position
		vec_rotate(camera.x,cam_ang);//rotate the camera origin to the angles
		vec_add(camera.x,cam_focus);//add the vectors to the cameras position(moves the camera)
		vec_diff(temp,cam_focus,camera.x);//get difference from cameras position and vectors
		vec_to_angle(camera.pan,temp);//rotate the cameras pan to that direction(points the camera)
		
//		

	scan_temp.x = 360;
	scan_temp.y = 360;
	//scan_temp.z = 650;//initial scan range no tech
	if(cam_dist == zoom_distance1)
	{
		scan_temp.z = 650;		
		
	}
		if(cam_dist == zoom_distance2)
	{
		scan_temp.z = 100000;		
		
	}
		if(cam_dist == zoom_distance3)
	{
		scan_temp.z = 100000;		
		
	}
		if(cam_dist == zoom_distance4)
	{
		scan_temp.z = 100000;		
		
	}
	detect_temp = scan_entity(me,scan_temp);
	if(detect_temp <= scan_temp.z)
		{
			//diag("\n?");
			//your.detected = on;
		}
	wait(1);
}

}


function move_map_ul()
{
	var move_factor_x;
	var move_factor_temp_x;
	var move_factor_y;
	var move_factor_temp_y;
	move_factor_x = -2560;
	move_factor_temp_x = 0;
	move_factor_y = 2560;
	move_factor_temp_y = 0;
	while(move_factor_temp_x > move_factor_x && move_factor_temp_y < move_factor_y)
	{
		cam_focus.x -= 80 * time;
		move_factor_temp_x -= 80 * time;
		cam_focus.y += 80 * time;
		move_factor_temp_y += 80 * time;
		wait(1);
		
	}	
}

function move_map_dl()
{
	var move_factor_x;
	var move_factor_temp_x;
	var move_factor_y;
	var move_factor_temp_y;
	move_factor_x = -2560;
	move_factor_temp_x = 0;
	move_factor_y = -2560;
	move_factor_temp_y = 0;
	while(move_factor_temp_x > move_factor_x && move_factor_temp_y > move_factor_y)
	{
		cam_focus.x -= 80 * time;
		move_factor_temp_x -= 80 * time;
		cam_focus.y -= 80 * time;
		move_factor_temp_y -= 80 * time;
		wait(1);
		
	}	
}

function move_map_ur()
{
	var move_factor_x;
	var move_factor_temp_x;
	var move_factor_y;
	var move_factor_temp_y;
	move_factor_x = 2560;
	move_factor_temp_x = 0;
	move_factor_y = 2560;
	move_factor_temp_y = 0;
	while(move_factor_temp_x < move_factor_x && move_factor_temp_y < move_factor_y)
	{
		cam_focus.x += 80 * time;
		move_factor_temp_x += 80 * time;
		cam_focus.y += 80 * time;
		move_factor_temp_y += 80 * time;
		wait(1);
		
	}	
}


function move_map_dr()
{
	var move_factor_x;
	var move_factor_temp_x;
	var move_factor_y;
	var move_factor_temp_y;
	move_factor_x = 2560;
	move_factor_temp_x = 0;
	move_factor_y = -2560;
	move_factor_temp_y = 0;
	while(move_factor_temp_x < move_factor_x && move_factor_temp_y > move_factor_y)
	{
		cam_focus.x += 80 * time;
		move_factor_temp_x += 80 * time;
		cam_focus.y -= 80 * time;
		move_factor_temp_y -= 80 * time;
		wait(1);
		
	}	
}


function move_map_uc()
{
	var move_factor;
	var move_factor_temp;
	move_factor = 2560;
	move_factor_temp = 0;
	while(move_factor_temp < move_factor)
	{
		cam_focus.y += 80 * time;
		move_factor_temp += 80 * time;
		wait(1);
		
	}	
}

function move_map_dc()
{
	var move_factor;
	var move_factor_temp;
	move_factor = -2560;
	move_factor_temp = 0;
	while(move_factor_temp > move_factor)
	{
		cam_focus.y -= 80 * time;
		move_factor_temp -= 80 * time;
		wait(1);
		
	}	
}

function move_map_cr()
{
	var move_factor;
	var move_factor_temp;
	move_factor = 2560;
	move_factor_temp = 0;
	while(move_factor_temp< move_factor)
	{
		cam_focus.x += 80 * time;
		move_factor_temp += 80 * time;
		wait(1);
		
	}
}

function move_map_cl()
{
	var move_factor;
	var move_factor_temp;
	move_factor = -2560;
	move_factor_temp = 0;
	while(move_factor_temp > move_factor)
	{
		cam_focus.x -= 80 * time;
		move_factor_temp -= 80 * time;
		wait(1);
		
	}	
}

function zoom_camera()
{
	while(1)
	{
		if(key_z == 1) 
		{
			if(!z_pressed && cam_dist == zoom_distance1)
			{
				z_pressed = 1;
				cam_dist = zoom_distance2;
				cam_ang.tilt = zoom_tilt2;
				camera.clip_far = 50000;
				//planet_cam.visible = off;
			}
      	if(!z_pressed && cam_dist == zoom_distance2)
      	{
      		z_pressed = 1;
      		cam_dist = zoom_distance3;
      		//moon_ent.invisible = on;
      		camera.clip_far = 50000;
				//planet_cam.visible = off;
				
      		
      		
      	}
      	if(!z_pressed && cam_dist == zoom_distance3)
      	{
      		z_pressed = 1;
      		cam_dist = zoom_distance4;
      		cam_ang.tilt = zoom_tilt3;
      		camera.clip_far = 50000;
				planet_cam.visible = off;
				
      		
      		
      	}
      	if(!z_pressed && cam_dist == zoom_distance4)
      	{
      		z_pressed = 1;
      		cam_dist = zoom_distance1;
				cam_ang.tilt = zoom_tilt1;
				camera.clip_far = 2000;
				planet_cam.visible = on;
				
				
      	}
      	}
      //close if block
    	if(cam_temp_dist < cam_dist)
    	{
    		cam_temp_dist = min(cam_dist,(cam_temp_dist + 50 * time));
    	}
    	if(cam_temp_dist > cam_dist)
    	{
    		cam_temp_dist = max(cam_dist,(cam_temp_dist - 50 * time));
    		}
    	if(cam_temp_tilt < cam_ang.tilt)
    	{
    		cam_temp_tilt = min(cam_ang.tilt,(cam_temp_tilt + 5 * time));
    		}
    		
    		if(cam_temp_tilt > cam_ang.tilt)
    	{
    		cam_temp_tilt = max(cam_ang.tilt,(cam_temp_tilt + 5 * time));
    		}
    if(cam_temp_dist < cam_dist) { cam_temp_dist = min(cam_dist,(cam_temp_dist + 30 * time)); }
    if(cam_temp_dist > cam_dist) { cam_temp_dist = max(cam_dist,(cam_temp_dist - 30 * time)); }
		if(!key_z) { z_pressed = 0; }
		wait(1);
	}


}
	
var toggle_cam = 0;


function toggle_camera()
{
	if(toggle_cam == 1)
	{
		planet_cam.size_x = 1280;
		planet_cam.size_y = 960;
		planet_cam.pos_x = 1;
		planet_cam.pos_y = 1;
		camera.size_x = 320;
		camera.size_y = 240;
		camera.x = 1;
		camera.y = 481;
		//planet_cam.layer = 30;
		toggle_cam -= 1;
		return;
	}
	if(toggle_cam == 0)
	{
		camera.size_x = 1280;
		camera.size_y = 960;
		planet_cam.size_x = 320;
		planet_cam.size_y = 240;
		planet_cam.pos_x = screen_size.x - 321;
		planet_cam.pos_y = pan_y4 + 300;
		toggle_cam += 1;
		return;
	}
	
}

on_z = zoom_camera();	// z key
on_c = toggle_camera(); // c key

function zoom_on_me(me)
{
	while(cam_focus.x < my.skill2)
	{
		cam_focus.x = min(my.skill2,(cam_focus.x + 50 * time));
		
    	wait(1);
    	}
   while(cam_focus.x > my.skill2)
   {
    	cam_focus.x = max(my.skill2,(cam_focus.x - 50 * time));
    	wait(1);
    	}
   while(cam_focus.y < my.skill3)
   {
   	cam_focus.y = min(my.skill3,(cam_focus.y + 50 * time));
    	wait(1);
    	}
   while(cam_focus.y > my.skill3)
   {
    	cam_focus.y = max(my.skill3,(cam_focus.y - 50 * time));
		wait(1);
    	}
	//cam_focus.x = my.skill2;
	//cam_focus.y = my.skill3;

}

function planet_cam_on_me(me)
{
	while(1)
	{
		
	//planet_cam.x = my.x - 20;
	planet_cam.y = my.y;
	planet_cam.z = my.z;
	planet_cam.clip_far = 5000;
	planet_cam.clip_near = 1;
	if(my.scale_x < 1 && my.scale_x >0)
	{
		planet_cam.x = my.x - 50;
	}
	if(my.scale_x >= 1 && my.scale_x < 2)
	{
		planet_cam.x = my.x - 250;
	}
	if(my.scale_x >= 2 && my.scale_x < 2.5)
	{
		planet_cam.x = my.x - 350;
		
	}
	if(my.scale_x >= 2.5 && my.scale_x < 3)
	{
		planet_cam.x = my.x - 450;
	}
	wait(1);
}
//	if(my.scale_x > 3&& my.scale_x < 4)
//	{
//		planet_cam.x = my.x - 450;
//	}
	//planet_cam.pan = 90;
}

function init_camera()
{
	//create camera_ent
	ent_create(dummy02_mdl, vector(0,0,0), camera_ent_func);
	//set map_cam
	map_cam.y = -10;
	map_cam.x = -300;
	map_cam.z = zoom_distance4;
	map_cam.tilt = zoom_tilt3;

	map_cam.clip_far = 100000;
	//set planet_cam
}
//
//
//////////////////////////////
// End
//////////////////////////////
endif;