ifndef menu_wdl;
define menu_wdl;

// ---------------------------------------------------------------------
// STARTHEADER
//
// ver: 4.1
// date: 050607
//
// title: Menu (01)
// class: INTERFACE
// type: USER
// image: menuSimple.pcx
// help: Add a simple, 4 item menu to your project.
// help: Simple menu includes: new, load, save, quit
// help: [ESC] key brings up main menu.
//
// needs: gid01.wdl, saveLoad00.wdl, saveLoad01.wdl, miscInput01.wdl
//
// prefix: menu01_
// idcode: 00F
//
// ENDHEADER
// ---------------------------------------------------------------------


//----------------------------------------------------------------------
// section: Main Menu Bitmaps

// entry: Item Background Bitmap
// help: Background image placed behind each menu item.
// id: 1
BMAP menu01_item_background_bmp = <menuBackground.pcx>;

// entry: Item Select Bitmap
// help: Background image placed behind the current selected menu item.
// id: 2
BMAP menu01_item_select_bmp = <menuSelect.pcx>;


//----------------------------------------------------------------------
// section: Main Menu Positions

// entry: Starting X
// id: 3
var menu01_pos_x = 10;
// entry: Starting Y
// id: 4
var menu01_pos_y = 10;

// entry: X Offset
// help: X offset of menu text relitive to button.
// id: 5
var menu01_txt_off_x = 2;
// entry: Y Offset
// help: Y offset of menu text relitive to button.
// id: 6
var menu01_txt_off_y = 1;

// entry: X Offset
// help: X offset of menu buttons
// id: 7
var menu01_butt_off_x = 4;
// entry: Y Offset
// help: Y offset of menu buttons
// id: 8
var menu01_butt_off_y = 12;

//----------------------------------------------------------------------
// section: Main Menu Item Strings and Order

// entry: Item Font
// help: Font used for menu item strings
// id: 9
font menu01_item_font = <ackfont.pcx>,6,9;

// entry: "New Game" item string
// help: The string used for the "New Game" menu item.
// id: 10
string menu01_item_new_game_str = "New";
// entry: Position in main menu.
// help: Enter 0 to remove this item from menu.
// id: 11
var menu01_item_new_game_pos = 1;

// entry: "Load Game" item string
// help: The string used for the "Load Game" menu item.
// help: Blank out string to disable this item.
// id: 12
string menu01_item_load_game_str = "Load";
// entry: Position in main menu.
// help: Enter 0 to remove this item from menu.
// id: 13
var menu01_item_load_game_pos = 2;

// entry: "Save Game" item string
// help: The string used for the "Save Game" menu item.
// help: Blank out string to disable this item.
// id: 14
string menu01_item_save_game_str = "Save";
// entry: Position in main menu.
// help: Enter 0 to remove this item from menu.
// id: 15
var menu01_item_save_game_pos = 3;

// entry: "Quit Game" item string
// help: The string used for the "Quit Game" menu item.
// help: Blank out string to disable this item.
// id: 16
string menu01_item_quit_game_str = "Quit";
// entry: Position in main menu.
// help: Enter 0 to remove this item from menu.
// id: 17
var menu01_item_quit_game_pos = 4;


//----------------------------------------------------------------------
//----------------------------------------------------------------------
// section: Confirm Menu Bitmaps

// entry: Confirm (yes/no) Background Bitmap
// help: background image placed behind the "yes/no" confirmation menu.
// id: 18
bmap menu01_confirm_panel_bmp = <confirmPanel.pcx>;
// entry: Confirm (yes/no) Item Bitmap
// help: background image placed behind the "yes/no" confirmation items.
// id: 19
bmap menu01_confirm_background_bmp = <confirmBackground.pcx>;
// entry: Confirm (yes/no) selected item bitmap
// help: background image placed behind selected "yes/no" confirmation items.
// id: 20
bmap menu01_confirm_select_bmp = <confirmSelect.pcx>;

//----------------------------------------------------------------------
// section: Activate Confim Menu?

// entry: Confirm Quit? (1-yes, 0-no)
// id: 21
var menu01_confirm_quit_b = 1;
// entry: Confirm "Quit" string
// entry_help: String displayed on confirm quit dialog
// id: 22
string menu01_confirm_quit_str = "Quit Game?";

// entry: Confirm New? (1-yes, 0-no)
// id: 23
var menu01_confirm_new_b = 1;
// entry: Confirm "Quit" string
// entry_help: String displayed on confirm new dialog
// id: 24
string menu01_confirm_new_str = "New Game?";

//----------------------------------------------------------------------
// section: Confirm Menu Positions

// entry: Starting X
// id: 25
var menu01_confirm_pos_x = 10;
// entry: Starting Y
// id: 26
var menu01_confirm_pos_y = 10;

// entry: X offset
// help: X offset of menu text relitive to button.
// id: 27
var menu01_confirm_txt_off_x = 2;
// entry: Y offset
// help: Y offset of menu text relitive to button.
// id: 28
var menu01_confirm_txt_off_y = 1;

// entry: X offset of menu buttons
// id: 29
var menu01_confirm_butt_off_x = 4;
// entry: Y offset of menu buttons
// id: 30
var menu01_confirm_butt_off_y = 12;

// entry: Width of confirm buttons
// id: 31
var menu01_confirm_butt_width = 28;

//----------------------------------------------------------------------
// section: Menu input (keyboard)

// entry: Activate menu key
// id: 32
//string menu01_activate_key_c = "ESC";

// entry: Next item down key
// id: 33
string menu01_item_down_key_c = "cud";
var	menu01_item_down_scancode = 0;
// entry: Previous item up key
// id: 34
string menu01_item_up_key_c = "cuu";
var	menu01_item_up_scancode = 0;
// entry: Previous item to the left key
// id: 35
string menu01_item_left_key_c = "cul";
var	menu01_item_left_scancode = 0;
// entry: Next item to the right key
// id: 36
string menu01_item_right_key_c = "cur";
var	menu01_item_right_scancode = 0;
// entry: Execute the current item key
// id: 37
string menu01_item_execute_key_c = "enter";
var	menu01_item_execute_scancode = 0;

//----------------------------------------------------------------------
// section: Menu Selection Sounds

// entry: Selection Sound
// entry_help: Sound played when the user moves to another selection.
// id: 38
sound  menu01_select_snd = <COMPUTER.wav>;

// entry: Execute Sound
// entry_help: Sound played when the user selects a menu item.
// id: 39
sound  menu01_execute_snd = <CONTROLL.wav>;


//----------------------------------------------------------------------
// section: Misc Menu Options

// enable: Freeze the game when the menu is displayed?
// id: 40
define menu01_freeze_game_b;







/////////////////////////////////////////////////////////////////////////
// Local variables

// is the menu active (0- no, 1- main menu, 2- confirm menu)
var menu01_active_b = 0;

// number of menu items
var menu01_item_count = 0;

// return value
var	menu01_rtn = 0;



// Local function prototypes
function menu01_play_select_snd();	// play click sound
function	menu01_select_new();			// new selected
function	menu01_select_quit();		// quit selected
function	menu01_select_save();		// save selected
function	menu01_select_load();		// load selected


// Function pointers
action* menu01_action1_ptr;
action* menu01_action2_ptr;
action* menu01_action3_ptr;
action* menu01_action4_ptr;

// functions used in the menu item panels
function menu01_item_1_function(){menu01_action1_ptr();}  // run function attached to item 1
function menu01_item_2_function(){menu01_action2_ptr();}  // run function attached to item 2
function menu01_item_3_function(){menu01_action3_ptr();}  // run function attached to item 3
function menu01_item_4_function(){menu01_action4_ptr();}  // run function attached to item 4

// The items of which the menu really consists.
// Each item is a panel with a single button.
panel menu01_item_1_pan
{
	layer = 200;
	flags = refresh;

	button = 0,0,								// x,y position
				menu01_item_select_bmp,		// button selected
				menu01_item_background_bmp,// button not selected
				menu01_item_select_bmp,  	// mouse over
				menu01_item_1_function,		// action on click
				NULL, 							// action on release
				menu01_play_select_snd; 	// action on mouse over
}
panel menu01_item_2_pan
{
	layer = 200;
	flags = refresh;

	button = 0,0,								// x,y position
				menu01_item_select_bmp,		// button selected
				menu01_item_background_bmp,// button not selected
				menu01_item_select_bmp,  	// mouse over
				menu01_item_2_function,		// action on click
				NULL, 							// action on release
				menu01_play_select_snd; 	// action on mouse over
}
panel menu01_item_3_pan
{
	layer = 200;
	flags = refresh;

	button = 0,0,								// x,y position
				menu01_item_select_bmp,		// button selected
				menu01_item_background_bmp,// button not selected
				menu01_item_select_bmp,  	// mouse over
				menu01_item_3_function,		// action on click
				NULL, 							// action on release
				menu01_play_select_snd; 	// action on mouse over
}
panel menu01_item_4_pan
{
	layer = 200;
	flags = refresh;

	button = 0,0,								// x,y position
				menu01_item_select_bmp,		// button selected
				menu01_item_background_bmp,// button not selected
				menu01_item_select_bmp,  	// mouse over
				menu01_item_4_function,		// action on click
				NULL, 							// action on release
				menu01_play_select_snd; 	// action on mouse over
}


panel menu01_item_select
{
	layer = 201.5;
	bmap = menu01_item_select_bmp;
	flags = REFRESH,TRANSPARENT;
}



// Texts on the menu item buttons
TEXT menu01_item_1_txt { layer = 201; FONT menu01_item_font; STRING = ""; }
TEXT menu01_item_2_txt { layer = 201; FONT menu01_item_font; STRING = ""; }
TEXT menu01_item_3_txt { layer = 201; FONT menu01_item_font; STRING = ""; }
TEXT menu01_item_4_txt { layer = 201; FONT menu01_item_font; STRING = ""; }



// Desc: Play the 'select another item' sound
function menu01_play_select_snd()
{
	// play select sound at 40% volume center balance.
	snd_play(menu01_select_snd,40,0);
}

// Desc: Play the 'execute menu item' sound
function menu01_play_execute_snd()
{
	// play select sound at 40% volume center balance.
	snd_play(menu01_execute_snd,40,0);
}

// Desc: assign str to menu item text
function menu01_set_text_main(item,str)
{
	if(1 == item)
	{
		menu01_item_1_txt.string = str;
	}
	if(2 == item)
	{
		menu01_item_2_txt.string = str;
	}
	if(3 == item)
	{
		menu01_item_3_txt.string = str;
	}
	if(4 == item)
	{
		menu01_item_4_txt.string = str;
	}
}


// desc: this function should never be called
function	menu01_dummy_function()
{
	return(1);  // continue the loop
}

// desc: return function pointer based on cmd
//  	1- new game function ptr
//		2- load game function ptr
//		3- save game function ptr
//		4- quit game function ptr
function	menu01_rtn_action_main(cmd)
{
	if(1 == cmd) { return(menu01_select_new);  } // return function ptr to new function
	if(2 == cmd) { return(menu01_select_load); } // return function ptr to load game menu
	if(3 == cmd) { return(menu01_select_save); } // return function ptr to save game menu
	if(4 == cmd) { return(menu01_select_quit); } // return function ptr to new function

	return(menu01_dummy_function);	// attach nothing
}

// Desc: assign the appopreate action to this menu item
function	menu01_set_action_main(item,cmd)
{
	if(1 == item)
	{
		menu01_action1_ptr = menu01_rtn_action_main(cmd);
	}
	if(2 == item)
	{
		menu01_action2_ptr = menu01_rtn_action_main(cmd);
	}
	if(3 == item)
	{
		menu01_action3_ptr = menu01_rtn_action_main(cmd);
	}
	if(4 == item)
	{
		menu01_action4_ptr = menu01_rtn_action_main(cmd);
	}
}



// Desc: Show the main menu panels.
function menu01_show_main()
{
					diag("\n pause game");

	if(menu01_item_count > 0)
	{
		// Set position button panel
		menu01_item_1_pan.POS_X = menu01_pos_x;
		menu01_item_1_pan.POS_Y = menu01_pos_y;

		// Set position of text
		menu01_item_1_txt.POS_X = menu01_pos_x + menu01_txt_off_x;
		menu01_item_1_txt.POS_Y = menu01_pos_y + menu01_txt_off_y;

		// Make visible
		menu01_item_1_pan.visible = ON;
		menu01_item_1_txt.visible = ON;
	}
	if(menu01_item_count > 1)
	{
		// Set position button panel
		menu01_item_2_pan.POS_X = (menu01_butt_off_x) + menu01_pos_x;
		menu01_item_2_pan.POS_Y = (menu01_butt_off_y) + menu01_pos_y;

		// Set position of text
		menu01_item_2_txt.POS_X = (menu01_butt_off_x) + menu01_pos_x + menu01_txt_off_x;
		menu01_item_2_txt.POS_Y = (menu01_butt_off_y) + menu01_pos_y + menu01_txt_off_y;

		// Make visible
		menu01_item_2_pan.visible = ON;
		menu01_item_2_txt.visible = ON;
	}
	if(menu01_item_count > 2)
	{
		// Set position button panel
		menu01_item_3_pan.POS_X = (2*menu01_butt_off_x) + menu01_pos_x;
		menu01_item_3_pan.POS_Y = (2*menu01_butt_off_y) + menu01_pos_y;

		// Set position of text
		menu01_item_3_txt.POS_X = (2*menu01_butt_off_x) + menu01_pos_x + menu01_txt_off_x;
		menu01_item_3_txt.POS_Y = (2*menu01_butt_off_y) + menu01_pos_y + menu01_txt_off_y;

		// Make visible
		menu01_item_3_pan.visible = ON;
		menu01_item_3_txt.visible = ON;
	}
	if(menu01_item_count > 3)
	{
		// Set position button panel
		menu01_item_4_pan.POS_X = (3*menu01_butt_off_x) + menu01_pos_x;
		menu01_item_4_pan.POS_Y = (3*menu01_butt_off_y) + menu01_pos_y;

		// Set position of text
		menu01_item_4_txt.POS_X = (3*menu01_butt_off_x) + menu01_pos_x + menu01_txt_off_x;
		menu01_item_4_txt.POS_Y = (3*menu01_butt_off_y) + menu01_pos_y + menu01_txt_off_y;

		// Make visible
		menu01_item_4_pan.visible = ON;
		menu01_item_4_txt.visible = ON;
	}

	menu01_item_select.visible = OFF;
}

// Desc: Hide the menu panels.
function	menu01_hide_main()
{
	menu01_item_1_pan.visible = OFF;
	menu01_item_1_txt.visible = OFF;
	menu01_item_2_pan.visible = OFF;
	menu01_item_2_txt.visible = OFF;
	menu01_item_3_pan.visible = OFF;
	menu01_item_3_txt.visible = OFF;
	menu01_item_4_pan.visible = OFF;
	menu01_item_4_txt.visible = OFF;

	menu01_item_select.visible = OFF;
}


// desc: highlight the current selected menu item
function	menu01_highlight(cur_item)
{
 	menu01_item_select.POS_X = menu01_pos_x + ((cur_item-1) * menu01_butt_off_x);
	menu01_item_select.POS_Y = menu01_pos_y + ((cur_item-1) * menu01_butt_off_y);
	menu01_item_select.visible = ON;
}


// desc: run the function attached to the menu item selected
function menu01_select(item)
{
 	if(1 == item)
	{
		menu01_action1_ptr();
	}
	if(2 == item)
	{
		menu01_action2_ptr();
	}
	if(3 == item)
	{
		menu01_action3_ptr();
	}
	if(4 == item)
	{
		menu01_action4_ptr();
	}
}

// desc: toggle on/off the menu loop
function	menu01_toggle_loop()
{
	if(menu01_active_b >= 1)    // is a menu already open?
	{
		menu01_active_b = 0;
		return;	// only one menu should be active
	}
	menu01_active_b = 1;

	//proc_kill(4);		// only one menu should be running

	var	cur_item; // current selected item

	cur_item = 1;

	menu01_show_main();

	ifdef menu01_freeze_game_b;
	//if(menu01_freeze_game_b == 1)
	//{
		freeze_mode = 1;	// when the menu is on screen, the game freezes
	//}
	endif;

	menu01_highlight(cur_item);	// show highlight

	while(menu01_active_b >= 1)
	{
		while(menu01_active_b >= 2)	// in a sub menu
		{
			wait(1);
		}

		// handle keyboard input
		if(Key_Pressed(menu01_item_down_scancode))
		{
			cur_item += 1;
			if(cur_item > menu01_item_count) { cur_item = menu01_item_count; }
			else { menu01_play_select_snd(); }
			menu01_highlight(cur_item);
			sleep(0.125); // wait an eigth of a second
		}
		if(Key_Pressed(menu01_item_up_scancode))
		{
			cur_item -= 1;
			if(cur_item < 1) { cur_item = 1; }
			else { Menu01_Play_Select_Snd(); }
			menu01_highlight(cur_item);
			sleep(0.125); // wait an eigth of a second
		}
		if(Key_Pressed(menu01_item_execute_scancode))
		{
			menu01_play_execute_snd();			// play execute sound
			sleep(0.250); // wait a quarter second
			menu01_select(cur_item);
		}

		wait(1);
	}
	menu01_hide_main();	// hide the menu
	ifdef menu01_freeze_game_b;
	//if(menu01_freeze_game_b == 1)
	//{
		freeze_mode = 0;	// un-freeze game
	//}
	endif;
	menu01_active_b = 0;	// menu is no longer active

}


// Desc: init the menu
starter menu01_Init()
{
	diag("\nWDL-Loaded:menu01.wdl");

	menu01_item_count = 0; // no items in menu
	menu01_active_b = 0; // menu not active

	/////////////////////////////
	// Set up keyboard scancodes
	/////////////////////////////
	// use MiscInput01_Key_For_Str() to convert strings into scancodes
	// next item down key
	str_cpy(miscInput01_temp_str,menu01_item_down_key_c);
	menu01_item_down_scancode = MiscInput01_Key_For_Str();
	// prev item up key
	str_cpy(miscInput01_temp_str,menu01_item_up_key_c);
	menu01_item_up_scancode = MiscInput01_Key_For_Str();
	// prev item left key
	str_cpy(miscInput01_temp_str,menu01_item_left_key_c);
	menu01_item_left_scancode = MiscInput01_Key_For_Str();
	// next item right key
	str_cpy(miscInput01_temp_str,menu01_item_right_key_c);
	menu01_item_right_scancode = MiscInput01_Key_For_Str();
	// select item key
	str_cpy(miscInput01_temp_str,menu01_item_execute_key_c);
	menu01_item_execute_scancode = MiscInput01_Key_For_Str();

	// check items
	if( menu01_item_new_game_pos > 0 )
	{
		// new game item valid
		menu01_item_count = menu01_item_new_game_pos;
		menu01_set_text_main(menu01_item_new_game_pos,menu01_item_new_game_str); // set text
		menu01_set_action_main(menu01_item_new_game_pos,1);	// set action
	}
	if( menu01_item_load_game_pos > 0 )
	{
		// load game item valid
		if(menu01_item_count < menu01_item_load_game_pos)
		{
			menu01_item_count = menu01_item_load_game_pos;
		}
		menu01_set_text_main(menu01_item_load_game_pos,menu01_item_load_game_str);
		menu01_set_action_main(menu01_item_load_game_pos,2);	// set action
	}
	if( menu01_item_save_game_pos > 0 )
	{
		// save game item valid
		if(menu01_item_count < menu01_item_save_game_pos)
		{
			menu01_item_count = menu01_item_save_game_pos;
		}
		menu01_set_text_main(menu01_item_save_game_pos,menu01_item_save_game_str);
		menu01_set_action_main(menu01_item_save_game_pos,3);	// set action
	}
	if( menu01_item_quit_game_pos > 0 )
	{
		// quit game item valid
		if(menu01_item_count < menu01_item_quit_game_pos)
		{
			menu01_item_count = menu01_item_quit_game_pos;
		}
		menu01_set_text_main(menu01_item_quit_game_pos,menu01_item_quit_game_str);
		menu01_set_action_main(menu01_item_quit_game_pos,4);	// set action
	}


}

/////////////////////////////////////////////////////////////////////////
// Yes/No confirm

text	menu01_confirm_txt { layer = 203; FONT menu01_item_font; STRING = ""; }
text	menu01_confirm_yes_txt { layer = 203; FONT menu01_item_font; STRING = "Yes"; }
text	menu01_confirm_no_txt { layer = 203; FONT menu01_item_font; STRING = "No"; }
panel menu01_confirm_pan
{
	layer = 202;
	flags = refresh;
	bmap = menu01_confirm_panel_bmp;
}

panel menu01_confirm_yes_pan
{
	layer = 202.5;
	flags = refresh;
	button = 0,0,									// x,y position
				menu01_confirm_select_bmp,		// button selected
				menu01_confirm_background_bmp,// button not selected
				menu01_confirm_select_bmp,  	// mouse over
				NULL,									// action on click
				NULL, 								// action on release
				menu01_play_select_snd; 		// action on mouse over
}
panel menu01_confirm_no_pan
{
	layer = 202.5;
	flags = refresh;
	button = 0,0,									// x,y position
				menu01_confirm_select_bmp,		// button selected
				menu01_confirm_background_bmp,// button not selected
				menu01_confirm_select_bmp,  	// mouse over
				NULL,									// action on click
				NULL, 								// action on release
				menu01_play_select_snd; 		// action on mouse over
}
panel menu01_confirm_select_pan
{
	layer = 203.5;
	bmap = menu01_confirm_select_bmp;
	flags = REFRESH,TRANSPARENT;
}


// desc: ....
function	menu01_confirm_select(cur_item)
{
	return(0);
}

// desc: highlight the current selected menu item
function	menu01_confirm_highlight(cur_item)
{
	menu01_confirm_select_pan.POS_X = menu01_confirm_pos_x + ((cur_item-1) * menu01_confirm_butt_off_x);
	menu01_confirm_select_pan.POS_Y = menu01_confirm_pos_y + menu01_confirm_butt_off_y;
	if(cur_item == 2) { menu01_confirm_select_pan.POS_X += menu01_confirm_butt_width; }
}

// desc: display the string and a simple "yes/no" confirm dialog
// sets temp to 1 - if user selected yes, 0 - otherwise
function	menu01_confirm_yn(str)
{
	var	cur_item; // current selected item
	cur_item = 1;  	// start with yes
	menu01_active_b = 2;	// let main menu know we are in a sub-menu

	// set up confirm menu position and strings
	menu01_confirm_txt.string = str;
	menu01_confirm_txt.pos_x = menu01_confirm_pos_x + menu01_confirm_txt_off_x;
	menu01_confirm_txt.pos_y = menu01_confirm_pos_y + menu01_confirm_txt_off_y;

	menu01_confirm_yes_txt.pos_x = menu01_confirm_pos_x + menu01_confirm_butt_off_x;
	menu01_confirm_yes_txt.pos_y = menu01_confirm_pos_y + menu01_confirm_butt_off_y;
	menu01_confirm_no_txt.pos_x =  menu01_confirm_pos_x + menu01_confirm_butt_off_x + menu01_confirm_butt_width;
	menu01_confirm_no_txt.pos_y =  menu01_confirm_pos_y + menu01_confirm_butt_off_y;

	menu01_confirm_pan.pos_x = menu01_confirm_pos_x;
	menu01_confirm_pan.pos_y = menu01_confirm_pos_y;

	// make visible
	menu01_confirm_txt.visible = on;
	menu01_confirm_yes_txt.visible = on;
	menu01_confirm_no_txt.visible = on;
	menu01_confirm_pan.visible = on;
	menu01_confirm_select_pan.visible = on;

	// highlight yes
	menu01_confirm_highlight(cur_item);

	// hide other panels
	menu01_hide_main();


	// user must release the select key
	while(Key_Pressed(menu01_item_execute_scancode)) { wait(1); }

	while(menu01_active_b >= 1)
	{
		// handle keyboard input
		if(Key_Pressed(menu01_item_right_scancode))
		{
			cur_item += 1;
			if(cur_item > 2) { cur_item = 2; }
			else { menu01_play_select_snd(); }
			menu01_confirm_highlight(cur_item);
			sleep(0.125); // wait an eigth of a second
		}
		if(Key_Pressed(menu01_item_left_scancode))
		{
			cur_item -= 1;
			if(cur_item < 1) { cur_item = 1; }
			else { menu01_play_select_snd(); }
			menu01_confirm_highlight(cur_item);
			sleep(0.125); // wait an eigth of a second
		}
		if(Key_Pressed(menu01_item_execute_scancode))
		{
			menu01_play_execute_snd();			// play execute sound
			sleep(0.250); // wait a quarter of a second
			menu01_confirm_select(cur_item);
			break;
		}

		wait(1);
	}
	// hide
	menu01_confirm_txt.visible = off;
	menu01_confirm_yes_txt.visible = off;
	menu01_confirm_no_txt.visible = off;
	menu01_confirm_pan.visible = off;
	menu01_confirm_select_pan.visible = off;

	if(menu01_active_b == 0)
	{
		// the user has escaped out of the menu
		menu01_rtn = 0; // don't quit
		return;
	}

	// user must release the select key
	while(Key_Pressed(menu01_item_execute_scancode)) { wait(1); }

	// return selection
	if(cur_item == 1)
	{
		menu01_rtn = 1; // user selected 'yes'
	}
	else
	{
		menu01_rtn = 0;	// user selected 'no'
	}

	menu01_active_b = 1; // return to main menu
	// show main menu panels
	menu01_show_main();

}


/////////////////////////////////////////////////////////////////////////
// Menu Item Functions
// Note: These are the default functions for each of the menu items.
//You can overwrite these with your own by redefining them after this
//script.

// function prototypes
function main_restart_game();	// from the 'main' template
function main_quit();			// from the 'main' template

// desc:
function	menu01_select_quit()
{
	menu01_rtn = -1;

	if(1 == menu01_confirm_quit_b)
	{
		menu01_rtn = -1;
		menu01_confirm_yn(menu01_confirm_quit_str);
  //		while(menu01_active_b >= 2)
		while(menu01_rtn < 0)
		{
			wait(1);
		}
		if(menu01_rtn == 0) { return(1); } // keep running menu
	}

	main_quit();	// call the quit function from the main template
	return(0);	// do not continue
}

function	menu01_select_new()
{
	menu01_rtn = -1;

	if(1 == menu01_confirm_new_b)
	{
		menu01_confirm_yn(menu01_confirm_new_str);
		while(menu01_active_b >= 2)
		{
			wait(1);
		}
		if(menu01_rtn == 0) { return(1); } // keep running menu
	}

	main_restart_game();
}

// Desc: open up the save sub-menu
//			pause the main menu for the durration of the sub-menu's run
//			quit the main menu on exit
function	menu01_select_save()
{
	menu01_hide_main();	// hide the menu
	menu01_active_b = 3;	// signal that we are in a sub-menu

	// call up a simple saveLoad00 save panel and pass control to it.
	saveLoad00_active = 1;
	SaveLoad00_SaveState_Display();	// run the saveLoad save panel

	while(saveLoad00_active == 1) { wait(1); }	// save game menu is running...

	menu01_active_b = 0;	// menu is no longer active (quit)
	return(0);	// do not continue
}

// Desc: open up the load sub-menu
//			pause the main menu for the durration of the sub-menu's run
//			quit the main menu on exit
function	menu01_select_load()
{
	menu01_hide_main();	// hide the menu
	menu01_active_b = 3;	// signal that we are in a sub-menu

	// call up a simple (00) saveLoad load panel and pass control to it.
	saveLoad00_active = 1;
	SaveLoad00_LoadState_Display();	// run the saveLoad load panel

	while(saveLoad00_active == 1) { wait(1); }	// save game menu is running...

	menu01_active_b = 0;	// menu is no longer active (quit)
	return(0);	// do not continue
}






ON_ESC menu01_toggle_loop;    // escape key toggles menu

endif;