// overlord_main.wdl


path "C:\\PROGRAM FILES\\GSTUDIO6\\!!!!Overlord";	// Path to A6 templates directory
path "C:\\PROGRAM FILES\\GSTUDIO6\\!!!!Overlord\\code";	// Path to A6 template code subdirectory
path "C:\\PROGRAM FILES\\GSTUDIO6\\!!!!Overlord\\images";	// Path to A6 template image subdirectory
path "C:\\PROGRAM FILES\\GSTUDIO6\\!!!!Overlord\\sounds";	// Path to A6 template sound subdirectory
path "C:\\PROGRAM FILES\\GSTUDIO6\\!!!!Overlord\\models";	// Path to A6 template model subdirectory

entity* id_this;

include <gid01.wdl>;
include <display00.wdl>;
include <miscInput01.wdl>;
include <sounds00.wdl>;
include <camera.wdl>;

include <player.wdl>;
include <tech_tree.wdl>;
include <panels01.wdl>;
include <probe.wdl>;
include <warship.wdl>;
//include <mouse00.wdl>;
include <cutscene01.wdl>;
include <startup01.wdl>;
include <saveLoad00.wdl>;
include <saveLoad01.wdl>;
include <menu01.wdl>;
//include <strings.wdl>;
include <mouse.wdl>;
include <materials.wdl>;


include <asteroids.wdl>;
//include <nebula.wdl>;
include <moons.wdl>;
//include <camp_planets.wdl>
include <planets01.wdl>;
//
include <suns.wdl>;
include <campaign.wdl>;


include <grid02.wdl>;
//include <fogofwar.wdl>;
//include <planets.wdl>;
//include <starships.wdl>;


string level_str = <overlord_main.WMB>; // give file names in angular brackets


//var time_smooth = 0.9;

var video_mode = 9;
var video_screen = 1;
var max_entities = 50000;
//var fps_max = 10;
//var fps_lock = on;



function main()
{
	// set some common flags and variables
	// freeze all entity functions
	freeze_mode = 1;
	// no level has been loaded yet...
	//gid01_level_state = gid01_level_not_loaded;

// entry: Warning Level (0,1, or 2)
// entry_help: Sets sensitivity to warnings (0 = none, 1 = some, 2 = all).
	warn_level = 2;	// announce bad texture sizes and bad wdl code


// entry: Starting Mouse Mode (0, 1, or 2)
	mouse_mode = 0;


// add random element
	randomize();
//	set max entities
	
	// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

	// now load the level
	level_load(level_str);

	wait(2);	// let level load
	// level should be loaded at this point...
	gid01_level_state = gid01_level_loaded;

//+++ load starting values
	init_mouse();
	init_player();
	init_camera();

		diag("\n init_mouse,player,camera done");
//	init_game();
	// un-freeze the game
	freeze_mode = 0;

	// save start of game here
	wait(6);   // allow time for functions that wait for "gid01_level_loaded" to load
	file_delete("start0.SAV");	// remove any old savefile
	wait(1);
	if( game_save("start",0,SV_ALL) <= 0)
	{
		diag("\nWARNING! main - Cannot save 'start' of level (ignore on restarts).");
	}
	else
	{
		diag("\nWDL: main - Game 'start' saved.");
	}


	// main game loop
	while(1)
	{
		
		if(gid01_level_state != gid01_level_loaded)
		{
			freeze_mode = 1;  // pause the game
			while(gid01_level_state != gid01_level_loaded) { 
				diag("\n pause game");
			
			wait(1); }
			freeze_mode = 0;  // resume the game
				diag("\n resume game");
			
		}
		wait(1);
	}

}





// Desc: this is the function used to restart the game.
function	main_restart_game()
{
	// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

	// freeze the game
	freeze_mode = 1;

	if( game_load("start",0) <= 0)
	{
		diag("\nWARNING! main_restart_game - Cannot load 'start' of level.");
	}
	else
	{
		diag("\nWDL: main_restart_game - Game 'start' loaded");
	}

	// un-freeze the game
	freeze_mode = 0;
}


// Desc: this is the function used to quit the game.
function	main_quit()
{
//+++			// save global skills & strings
	exit;
}

/////////////////////////////////////////////////////////////////
// The following definitions are for the pro edition window composer
// to define the start and exit window of the application.
WINDOW WINSTART
{
	TITLE			"3D GameStudio";
	SIZE			480,320;
	MODE			IMAGE;	//STANDARD;
	BG_COLOR		RGB(240,240,240);
	FRAME			FTYP1,0,0,480,320;
//	BUTTON		BUTTON_START,SYS_DEFAULT,"Start",400,288,72,24;
	BUTTON		BUTTON_QUIT,SYS_DEFAULT,"Abort",400,288,72,24;
	TEXT_STDOUT	"Arial",RGB(0,0,0),10,10,460,280;
}

/* no exit window at all..
WINDOW WINEND
{
	TITLE			"Finished";
	SIZE			540,320;
	MODE	 		STANDARD;
	BG_COLOR		RGB(0,0,0);
	TEXT_STDOUT	"",RGB(255,40,40),10,20,520,270;

	SET FONT		"",RGB(0,255,255);
	TEXT			"Any key to exit",10,270;
}*/


/////////////////////////////////////////////////////////////////
